package com.uas.cloud.oauth2.entity;

import javax.persistence.*;

/**
 * Created by Pro1 on 2017/3/22.
 */
@Entity
@IdClass(OAuth2ClientScopeId.class)
@Table(name = "oauth2_client_scopes")
public class OAuth2ClientScope {

    @Id
    @Column(name = "client_id", length = 32)
    private String clientId;

    @Id
    @Column(name = "scope_id")
    private Long scopeId;

    @Column(name = "auto_approve")
    private Boolean autoApprove;

    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JoinColumn(name = "client_id", insertable = false, updatable = false, nullable = false)
    private OAuth2Client client;

    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JoinColumn(name = "scope_id", insertable = false, updatable = false, nullable = false)
    private OAuth2Scope scope;

    public String getClientId() {
        return clientId;
    }

    public void setClientId(String clientId) {
        this.clientId = clientId;
    }

    public Long getScopeId() {
        return scopeId;
    }

    public void setScopeId(Long scopeId) {
        this.scopeId = scopeId;
    }

    public Boolean getAutoApprove() {
        return autoApprove;
    }

    public void setAutoApprove(Boolean autoApprove) {
        this.autoApprove = autoApprove;
    }

    public OAuth2Client getClient() {
        return client;
    }

    public void setClient(OAuth2Client client) {
        this.client = client;
    }

    public OAuth2Scope getScope() {
        return scope;
    }

    public void setScope(OAuth2Scope scope) {
        this.scope = scope;
    }

}
