package com.uas.cloud.oauth2.entity;

import javax.persistence.*;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Collection;

/**
 * 用户账户
 * Created by Pro1 on 2017/3/22.
 */
@Entity
@Table(name = "user_accounts")
public class UserAccount {

    @Id
    @Column(name = "id")
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column(name = "expires_at")
    private LocalDateTime expiresAt;

    @Column(name = "locked", nullable = false)
    private boolean locked;

    @Column(name = "disabled", nullable = false)
    private boolean disabled;

    @OneToOne(fetch = FetchType.LAZY)
    @PrimaryKeyJoinColumn
    private UserProfile profile;

    @OneToMany(fetch = FetchType.LAZY, mappedBy = "account")
    private Collection<UserCredential> credentials = new ArrayList<UserCredential>();

    @OneToMany(fetch = FetchType.LAZY, mappedBy = "userAccount")
    private Collection<OAuth2Account> oAuth2Accounts = new ArrayList<OAuth2Account>();

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public LocalDateTime getExpiresAt() {
        return expiresAt;
    }

    public void setExpiresAt(LocalDateTime expiresAt) {
        this.expiresAt = expiresAt;
    }

    public boolean isLocked() {
        return locked;
    }

    public void setLocked(boolean locked) {
        this.locked = locked;
    }

    public boolean isDisabled() {
        return disabled;
    }

    public void setDisabled(boolean disabled) {
        this.disabled = disabled;
    }

    public UserProfile getProfile() {
        return profile;
    }

    public void setProfile(UserProfile profile) {
        this.profile = profile;
    }

    public Collection<UserCredential> getCredentials() {
        return credentials;
    }

    public void setCredentials(Collection<UserCredential> credentials) {
        this.credentials = credentials;
    }

    public Collection<OAuth2Account> getoAuth2Accounts() {
        return oAuth2Accounts;
    }

    public void setoAuth2Accounts(Collection<OAuth2Account> oAuth2Accounts) {
        this.oAuth2Accounts = oAuth2Accounts;
    }
}
