package com.uas.cloud.oauth2.entity;

import javax.persistence.*;
import java.time.LocalDateTime;

/**
 * 用户凭据
 * Created by Pro1 on 2017/3/22.
 */
@Entity
@Table(name = "user_credentials")
public class UserCredential {

    @Id
    @Column(name = "id")
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column(name = "provider_key", nullable = false, length = 128)
    private String providerKey;

    @Column(name = "user_key", unique = true, nullable = false, length = 256)
    private String userKey;

    @Column(name = "secret_code", length = 256)
    private String secretCode;

    @Column(name = "salt", length = 128)
    private String salt;

    @Column(name = "expires_at")
    private LocalDateTime expiresAt;

    @Column(name = "account_id", nullable = false)
    private Long accountId;

    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JoinColumn(name = "account_id", insertable = false, updatable = false, nullable = false)
    private UserAccount account;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getProviderKey() {
        return providerKey;
    }

    public void setProviderKey(String providerKey) {
        this.providerKey = providerKey;
    }

    /**
     * @return 用户名：账户ID、手机号、邮箱
     */
    public String getUserKey() {
        return userKey;
    }

    public void setUserKey(String userKey) {
        this.userKey = userKey;
    }

    /**
     * @return 密码密文
     */
    public String getSecretCode() {
        return secretCode;
    }

    public void setSecretCode(String secretCode) {
        this.secretCode = secretCode;
    }

    /**
     * @return 过期时间
     */
    public LocalDateTime getExpiresAt() {
        return expiresAt;
    }

    public void setExpiresAt(LocalDateTime expiresAt) {
        this.expiresAt = expiresAt;
    }

    public Long getAccountId() {
        return accountId;
    }

    public void setAccountId(Long accountId) {
        this.accountId = accountId;
    }

    public UserAccount getAccount() {
        return account;
    }

    public void setAccount(UserAccount account) {
        this.account = account;
    }

    /**
     * @return 密码加密盐值
     */
    public String getSalt() {
        return salt;
    }

    public void setSalt(String salt) {
        this.salt = salt;
    }
}
