package com.uas.cloud.oauth2.entity;

import javax.persistence.*;
import java.time.LocalDate;

/**
 * 用户信息
 * Created by Pro1 on 2017/3/22.
 */
@Entity
@Table(name = "user_profiles")
public class UserProfile {
    @Id
    @Column(name = "id")
    private Long id;

    @Column(name = "name", nullable = false, length = 64)
    private String name;

    @Column(name = "gender", length = 32)
    private String gender;

    @Column(name = "birthday")
    private LocalDate birthday;

    @Column(name = "telephone", length = 64)
    private String telephone;

    @Column(name = "mobile", length = 64)
    private String mobile;

    @Column(name = "email", length = 128)
    private String email;

    @OneToOne(fetch = FetchType.LAZY, optional = false)
    @PrimaryKeyJoinColumn
    private UserAccount account;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    /**
     * 性别
     * @return
     */
    public String getGender() {
        return gender;
    }

    public void setGender(String gender) {
        this.gender = gender;
    }

    /**
     * 出生日期
     * @return
     */
    public LocalDate getBirthday() {
        return birthday;
    }

    public void setBirthday(LocalDate birthday) {
        this.birthday = birthday;
    }

    /**
     * 电话
     * @return
     */
    public String getTelephone() {
        return telephone;
    }

    public void setTelephone(String telephone) {
        this.telephone = telephone;
    }

    /**
     * 手机号
     * @return
     */
    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    /**
     * 邮箱
     * @return
     */
    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public UserAccount getAccount() {
        return account;
    }

    public void setAccount(UserAccount account) {
        this.account = account;
    }

}
