package com.uas.cloud.oauth2.provider;

import com.uas.cloud.oauth2.entity.OAuth2Client;
import com.uas.cloud.oauth2.repository.OAuth2ClientRepository;
import com.uas.cloud.oauth2.repository.OAuth2ScopeRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.oauth2.provider.ClientDetails;
import org.springframework.security.oauth2.provider.ClientDetailsService;
import org.springframework.security.oauth2.provider.ClientRegistrationException;
import org.springframework.security.oauth2.provider.client.BaseClientDetails;
import org.springframework.stereotype.Component;

/**
 * Created by Pro1 on 2017/3/22.
 */
@Component
public class JpaClientDetailsService implements ClientDetailsService {

    private final OAuth2ClientRepository oAuth2ClientRepository;
    private final OAuth2ScopeRepository oAuth2ScopeRepository;

    @Autowired
    public JpaClientDetailsService(OAuth2ClientRepository oAuth2ClientRepository, OAuth2ScopeRepository oAuth2ScopeRepository) {
        this.oAuth2ClientRepository = oAuth2ClientRepository;
        this.oAuth2ScopeRepository = oAuth2ScopeRepository;
    }

    public ClientDetails loadClientByClientId(String clientId) throws ClientRegistrationException {
        OAuth2Client oAuth2Client = oAuth2ClientRepository.findOne(clientId);
        BaseClientDetails clientDetails = new BaseClientDetails(
                oAuth2Client.getId(),
                oAuth2Client.getResourceIds(),
                null,
                oAuth2Client.getGrantTypes(),
                oAuth2Client.getAuthorities(),
                oAuth2Client.getRedirectUris()
        );
        clientDetails.setClientSecret(oAuth2Client.getSecret());
        clientDetails.setScope(oAuth2ScopeRepository.findScopeKeysByClientId(clientId));
        return clientDetails;
    }
}
