package com.uas.cloud.oauth2.repository;

import com.uas.cloud.oauth2.entity.OAuth2Scope;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.Set;

/**
 * Created by Pro1 on 2017/3/22.
 */
@Repository
public interface OAuth2ScopeRepository extends JpaRepository<OAuth2Scope, Long> {

    @Query("select distinct(s.key) from OAuth2Scope s" +
            " left join s.clientScopes cs" +
            " where s.clientId = :clientId or cs.clientId = :clientId")
    Set<String> findScopeKeysByClientId(@Param("clientId") String clientId);
}
